"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParticipantModel = exports.ServiceConfigurationModel = exports.PeerconnectionModel = exports.DeviceModel = exports.RoleModel = exports.ExperimentModel = void 0;
const typeorm_1 = require("typeorm");
let ExperimentModel = class ExperimentModel {
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('uuid'),
    __metadata("design:type", String)
], ExperimentModel.prototype, "uuid", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], ExperimentModel.prototype, "status", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], ExperimentModel.prototype, "bookingStart", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], ExperimentModel.prototype, "bookingEnd", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => DeviceModel, (device) => device.experiment, {
        onDelete: 'CASCADE',
        cascade: true,
    }),
    __metadata("design:type", Array)
], ExperimentModel.prototype, "devices", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => RoleModel, (role) => role.experiment, { eager: true, onDelete: 'CASCADE', cascade: true }),
    __metadata("design:type", Array)
], ExperimentModel.prototype, "roles", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => PeerconnectionModel, (peerconnection) => peerconnection.experiment, {
        onDelete: 'CASCADE',
        cascade: true,
    }),
    __metadata("design:type", Array)
], ExperimentModel.prototype, "connections", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => ServiceConfigurationModel, (serviceConfiguration) => serviceConfiguration.experiment, { onDelete: 'CASCADE', cascade: true }),
    __metadata("design:type", Array)
], ExperimentModel.prototype, "serviceConfigurations", void 0);
__decorate([
    (0, typeorm_1.Column)({ nullable: true }),
    __metadata("design:type", String)
], ExperimentModel.prototype, "bookingID", void 0);
__decorate([
    (0, typeorm_1.DeleteDateColumn)(),
    __metadata("design:type", Date)
], ExperimentModel.prototype, "deletedAt", void 0);
ExperimentModel = __decorate([
    (0, typeorm_1.Entity)({ name: 'Experiment' })
], ExperimentModel);
exports.ExperimentModel = ExperimentModel;
let RoleModel = class RoleModel {
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('uuid'),
    __metadata("design:type", String)
], RoleModel.prototype, "uuid", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], RoleModel.prototype, "name", void 0);
__decorate([
    (0, typeorm_1.Column)("text", { nullable: true }),
    __metadata("design:type", Object)
], RoleModel.prototype, "description", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => ExperimentModel, (experiment) => experiment.roles),
    __metadata("design:type", ExperimentModel)
], RoleModel.prototype, "experiment", void 0);
RoleModel = __decorate([
    (0, typeorm_1.Entity)({ name: 'Role' })
], RoleModel);
exports.RoleModel = RoleModel;
let DeviceModel = class DeviceModel {
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('uuid'),
    __metadata("design:type", String)
], DeviceModel.prototype, "uuid", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], DeviceModel.prototype, "url", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], DeviceModel.prototype, "role", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => ExperimentModel, (experiment) => experiment.devices),
    __metadata("design:type", ExperimentModel)
], DeviceModel.prototype, "experiment", void 0);
__decorate([
    (0, typeorm_1.Column)('simple-json', { nullable: true }),
    __metadata("design:type", Object)
], DeviceModel.prototype, "additionalProperties", void 0);
DeviceModel = __decorate([
    (0, typeorm_1.Entity)({ name: 'Device' })
], DeviceModel);
exports.DeviceModel = DeviceModel;
let PeerconnectionModel = class PeerconnectionModel {
};
__decorate([
    (0, typeorm_1.PrimaryColumn)(),
    __metadata("design:type", String)
], PeerconnectionModel.prototype, "url", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => ExperimentModel, (experiment) => experiment.connections),
    __metadata("design:type", ExperimentModel)
], PeerconnectionModel.prototype, "experiment", void 0);
PeerconnectionModel = __decorate([
    (0, typeorm_1.Entity)({ name: 'Peerconnection' })
], PeerconnectionModel);
exports.PeerconnectionModel = PeerconnectionModel;
let ServiceConfigurationModel = class ServiceConfigurationModel {
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('uuid'),
    __metadata("design:type", String)
], ServiceConfigurationModel.prototype, "uuid", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], ServiceConfigurationModel.prototype, "serviceType", void 0);
__decorate([
    (0, typeorm_1.Column)("simple-json"),
    __metadata("design:type", Object)
], ServiceConfigurationModel.prototype, "configuration", void 0);
__decorate([
    (0, typeorm_1.OneToMany)(() => ParticipantModel, (participant) => participant.serviceConfiguration, { onDelete: 'CASCADE', cascade: true }),
    __metadata("design:type", Array)
], ServiceConfigurationModel.prototype, "participants", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => ExperimentModel, (experiment) => experiment.serviceConfigurations),
    __metadata("design:type", ExperimentModel)
], ServiceConfigurationModel.prototype, "experiment", void 0);
ServiceConfigurationModel = __decorate([
    (0, typeorm_1.Entity)({ name: 'ServiceConfiguration' })
], ServiceConfigurationModel);
exports.ServiceConfigurationModel = ServiceConfigurationModel;
let ParticipantModel = class ParticipantModel {
};
__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)('uuid'),
    __metadata("design:type", String)
], ParticipantModel.prototype, "uuid", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], ParticipantModel.prototype, "role", void 0);
__decorate([
    (0, typeorm_1.Column)(),
    __metadata("design:type", String)
], ParticipantModel.prototype, "serviceId", void 0);
__decorate([
    (0, typeorm_1.Column)("simple-json"),
    __metadata("design:type", Object)
], ParticipantModel.prototype, "config", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => ServiceConfigurationModel, (serviceConfiguration) => serviceConfiguration.participants),
    __metadata("design:type", ServiceConfigurationModel)
], ParticipantModel.prototype, "serviceConfiguration", void 0);
ParticipantModel = __decorate([
    (0, typeorm_1.Entity)({ name: 'Participant' })
], ParticipantModel);
exports.ParticipantModel = ParticipantModel;
//# sourceMappingURL=model.js.map