"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * This file was automatically generated by openapi-codegeneration.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source OpenAPI file,
 * and run openapi-codegeneration to regenerate this file.
 */
const operations_1 = __importDefault(require("../operations"));
const requestValidation_1 = require("./requestValidation");
const types_1 = require("./types");
const express_1 = __importDefault(require("express"));
function routes(options) {
    const router = express_1.default.Router();
    async function handleSecurityRequirement(request, securityRequirement) {
        const userDataEntries = [];
        for (const method in securityRequirement) {
            const user = await options.security[method](request, securityRequirement[method]);
            if (!(0, types_1.isUserType)(user))
                throw new Error(`User resolved by method ${method} is not of type 'UserType'`);
            userDataEntries.push([method, user]);
        }
        return Object.fromEntries(userDataEntries);
    }
    router.get('/experiments', async (req, res, next) => {
        const security = [
            {
                JWT: [
                    'experiment',
                    'experiment:read',
                    'experiment:read:owned',
                ],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        try {
            if (!(0, requestValidation_1.validateGetExperimentsInput)()) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validateGetExperimentsInput.errors, 400);
            }
            const result = await operations_1.default.getExperiments(userData);
            if (!(0, requestValidation_1.validateGetExperimentsOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validateGetExperimentsOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post('/experiments', async (req, res, next) => {
        const security = [
            {
                JWT: ['experiment', 'experiment:create'],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePostExperimentsInput)(body)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validatePostExperimentsInput.errors, 400);
            }
            const result = await operations_1.default.postExperiments(body, userData);
            if (!(0, requestValidation_1.validatePostExperimentsOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validatePostExperimentsOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.get('/experiments/:experiment_id', async (req, res, next) => {
        const security = [
            {
                JWT: [
                    'experiment',
                    'experiment:read',
                    'experiment:read:owned',
                ],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            experiment_id: req.params['experiment_id'],
        };
        try {
            if (!(0, requestValidation_1.validateGetExperimentsByExperimentIdInput)(parameters)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validateGetExperimentsByExperimentIdInput.errors, 400);
            }
            const result = await operations_1.default.getExperimentsByExperimentId(parameters, userData);
            if (!(0, requestValidation_1.validateGetExperimentsByExperimentIdOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validateGetExperimentsByExperimentIdOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.patch('/experiments/:experiment_id', async (req, res, next) => {
        const security = [
            {
                JWT: [
                    'experiment',
                    'experiment:write',
                    'experiment:write:owned',
                ],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            experiment_id: req.params['experiment_id'],
            changedURL: req.query['changedURL'],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePatchExperimentsByExperimentIdInput)(parameters, body)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validatePatchExperimentsByExperimentIdInput.errors, 400);
            }
            const result = await operations_1.default.patchExperimentsByExperimentId(parameters, body, userData);
            if (!(0, requestValidation_1.validatePatchExperimentsByExperimentIdOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validatePatchExperimentsByExperimentIdOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.delete('/experiments/:experiment_id', async (req, res, next) => {
        const security = [
            {
                JWT: [
                    'experiment',
                    'experiment:delete',
                    'experiment:delete:owned',
                ],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error('Request could not be authenticated'));
            return;
        }
        const parameters = {
            experiment_id: req.params['experiment_id'],
        };
        try {
            if (!(0, requestValidation_1.validateDeleteExperimentsByExperimentIdInput)(parameters)) {
                throw new types_1.ValidationError('Request validation failed', requestValidation_1.validateDeleteExperimentsByExperimentIdInput.errors, 400);
            }
            const result = await operations_1.default.deleteExperimentsByExperimentId(parameters, userData);
            if (!(0, requestValidation_1.validateDeleteExperimentsByExperimentIdOutput)(result)) {
                throw new types_1.ValidationError('Response validation failed', requestValidation_1.validateDeleteExperimentsByExperimentIdOutput.errors, 500);
            }
            for (const headerName in result.headers) {
                const header = result.headers[headerName];
                if (header) {
                    res.setHeader(headerName, header);
                }
            }
            return res.status(result.status).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    return router;
}
exports.default = routes;
//# sourceMappingURL=routes.js.map